2017-06-20 05:31:43 +08:00
#!/bin/bash
2017-06-21 04:17:41 +08:00
echo -en "Checking internet connection... "
timeout 1 bash -c "echo >/dev/tcp/8.8.8.8/53"
if [ [ $? != 0 ] ] ; then
echo -e "\e[31mfailed\e[0m"
exit 1
else
echo -e "\e[32mOK\e[0m"
fi
2017-06-21 05:05:43 +08:00
if [ [ -z $( which curl) ] ] ; then echo "Cannot find curl, exiting." ; exit 1; fi
if [ [ -z $( which docker-compose) ] ] ; then echo "Cannot find docker-compose, exiting." ; exit 1; fi
2017-06-21 05:22:39 +08:00
if [ [ -z $( which docker) ] ] ; then echo "Cannot find docker, exiting." ; exit 1; fi
2017-06-21 05:05:43 +08:00
if [ [ -z $( which git) ] ] ; then echo "Cannot find git, exiting." ; exit 1; fi
2017-06-21 05:41:25 +08:00
if [ [ -z $( which awk) ] ] ; then echo "Cannot find awk, exiting." ; exit 1; fi
if [ [ -z $( which sha1sum) ] ] ; then echo "Cannot find sha1sum, exiting." ; exit 1; fi
2017-06-21 17:05:59 +08:00
[ [ -z $( grep update.sh .gitignore) ] ] && echo "update.sh" >> .gitignore
2017-06-20 05:31:43 +08:00
set -o pipefail
export LC_ALL = C
2017-06-20 06:02:03 +08:00
DATE = $( date +%Y-%m-%d_%H_%M_%S)
2017-06-20 05:31:43 +08:00
BRANCH = $( git rev-parse --abbrev-ref HEAD)
2017-06-21 05:41:25 +08:00
TMPFILE = $( mktemp " ${ TMPDIR :- /tmp } /curldata.XXXXXX " )
curl -#o ${ TMPFILE } https://raw.githubusercontent.com/mailcow/mailcow-dockerized/dev/update.sh
if [ [ $( sha1sum ${ TMPFILE } | awk '{ print $1 }' ) != $( sha1sum ./update.sh | awk '{ print $1 }' ) ] ] ; then
echo "Updating script, please run this script again, exiting."
2017-06-21 05:43:19 +08:00
chmod +x ${ TMPFILE }
2017-06-21 05:41:25 +08:00
mv ${ TMPFILE } ./update.sh
exit 0
fi
2017-06-21 05:43:19 +08:00
rm -f mv ${ TMPFILE }
2017-06-21 04:17:41 +08:00
2017-06-21 03:40:15 +08:00
if [ [ -f mailcow.conf ] ] ; then
source mailcow.conf
else
echo -e "\e[31mNo mailcow.conf - is mailcow installed?\e[0m"
exit 1
fi
2017-06-20 05:31:43 +08:00
2017-06-21 05:05:43 +08:00
read -r -p "Are you sure? [y/N] " response
if [ [ ! " $response " = ~ ^( [ yY] [ eE] [ sS] | [ yY] ) +$ ] ] ; then
echo "OK, exiting."
exit 0
fi
echo -e "Stopping mailcow... "
2017-06-21 03:21:21 +08:00
# Stopping mailcow
docker-compose down
2017-06-20 05:31:43 +08:00
# Silently fixing remote url from andryyy to mailcow
git remote set-url origin https://github.com/mailcow/mailcow-dockerized
echo -e "\e[32mCommitting current status...\e[90m"
git add -u
git commit -am " Before update on ${ DATE } " > /dev/null
echo -e "\e[32mFetching updated code from remote...\e[90m"
2017-06-21 02:42:11 +08:00
git fetch origin ${ BRANCH }
2017-06-21 05:05:43 +08:00
echo -e "\e[32mMerging local with remote code (recursive, options: \"theirs\", \"patience\"...\e[90m"
2017-06-20 05:31:43 +08:00
git merge -Xtheirs -Xpatience -m " After update on ${ DATE } "
2017-06-21 17:05:59 +08:00
if [ [ $? = = 128 ] ] ; then
echo -e "\e[31m\nOh no, what happened?\n=> You most likely added files to your local mailcow instance that were now added to the official mailcow repository. Please move them to another location before updating mailcow."
elif [ [ $? = = 1 ] ] ; then
2017-06-20 06:03:09 +08:00
echo -e "\e[31mRun into conflict, trying to fix...\e[90m"
git status --porcelain | grep -E "UD|DU" | awk '{print $2}' | xargs rm -v
git add -A
git commit -m " After update on ${ DATE } " > /dev/null
git checkout .
echo -e "\e[32mRemoved and recreated files if necessary.\e[90m"
2017-06-20 05:31:43 +08:00
fi
2017-06-21 03:21:21 +08:00
echo -e "\e[32mFetching new images, if any...\e[0m"
docker-compose pull
2017-06-20 06:02:03 +08:00
echo
2017-06-21 05:22:39 +08:00
2017-06-21 03:21:21 +08:00
#echo -e "\e[32mHashes to revert to:\e[0m"
#git reflog --color=always | grep "Before update on "
2017-06-20 06:03:09 +08:00
# TODO: Menu, select hard reset, select reset to "before update" etc.
2017-06-20 05:31:43 +08:00
#git reset --hard origin/${BRANCH}
2017-06-21 03:40:15 +08:00
# Fix missing SSL, does not overwrite existing files
[ [ ! -d data/assets/ssl ] ] && mkdir -p data/assets/ssl
cp -n data/assets/ssl-example/*.pem data/assets/ssl/
2017-06-21 04:17:41 +08:00
2017-06-21 05:05:43 +08:00
curl -L https://github.com/docker/compose/releases/download/$( curl -Ls https://www.servercow.de/docker-compose/latest.php) /docker-compose-$( uname -s) -$( uname -m) > $( which docker-compose)
chmod +x $( which docker-compose)
2017-06-21 05:22:39 +08:00
docker-compose up -d --remove-orphans
#echo -e "\e[32mCleaning up...\e[0m"
if docker images -f "dangling=true" | grep ago --quiet; then
docker rmi -f $( docker images -f "dangling=true" -q)
docker volume rm $( docker volume ls -qf dangling = true )
fi